/**
 * Dragon - SOA Governance Platform.
 * Copyright (c) 2008 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * GenericOSEMDAO.java
 * -------------------------------------------------------------------------
 */

package org.ow2.dragon.persistence.dao;

import java.io.Serializable;
import java.util.List;

/**
 * @author ofabre - eBM Websourcing
 * 
 */
public interface GenericOSEMDAO<T, PK extends Serializable> {

    /**
     * Return a {@link List} of entity managed by the Full Text Search Engine.
     * Only the search engine managed attributes of these entities are populated
     * 
     * @param query
     *            a Lucene {@link String} query
     * @return a {@link List} of entity managed by the Full Text Search Engine.
     */
    List<T> search(String query);

    /**
     * Return the type of entity manipulated by this DAO
     * 
     * @return the {@link Class} of the manipulated entity
     */
    Class<T> getManipulatedType();

}
