/**
 * Dragon - SOA Governance Platform.
 * Copyright (c) 2009 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * CategoryDAO.java
 * -------------------------------------------------------------------------
 */

package org.ow2.dragon.persistence.dao.common;

import java.util.List;

import org.ow2.dragon.persistence.bo.common.Category;
import org.ow2.dragon.persistence.bo.common.TModel;
import org.ow2.dragon.persistence.bo.deployment.Endpoint;
import org.ow2.dragon.persistence.bo.deployment.TechnicalService;
import org.ow2.dragon.persistence.bo.organization.OrganizationUnit;
import org.ow2.dragon.persistence.dao.GenericORMDAO;

/**
 * @author ofabre
 * 
 */
public interface CategoryDAO extends GenericORMDAO<Category, String> {

    /**
     * Return a {@link List} of {@link Category} related to
     * {@link TechnicalService}
     * 
     * @return a {@link List} of {@link Category} related to
     *         {@link TechnicalService}
     */
    List<Category> loadServiceRelatedCategories();

    /**
     * Return a {@link List} of {@link Category} related to
     * {@link OrganizationUnit}
     * 
     * @return a {@link List} of {@link Category} related to
     *         {@link OrganizationUnit}
     */
    List<Category> loadOrganizationRelatedCategories();

    /**
     * Return a {@link List} of {@link Category} related to {@link Endpoint}
     * 
     * @return a {@link List} of {@link Category} related to {@link Endpoint}
     */
    List<Category> loadEndpointRelatedCategories();

    /**
     * Return a {@link List} of {@link Category} related to {@link TModel}
     * 
     * @return a {@link List} of {@link Category} related to {@link TModel}
     */
    List<Category> loadTModelRelatedCategories();
}
