/**
 * Petals Master - SOA Governance Platform.
 * Copyright (c) 2010 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * ImportedService.java
 * -------------------------------------------------------------------------
 */

package org.ow2.dragon.service.wsdl.importreport;

import java.util.ArrayList;
import java.util.List;

/**
 * @author ofabre
 * 
 */
public class ImportedService {

    private String id;

    private boolean alreadyRegistered;

    private String name;

    private List<ImportedEndpoint> eps;

    /**
     * @param alreadyRegistered
     * @param name
     */
    public ImportedService(String id, boolean alreadyRegistered, String name) {
        super();
        this.id = id;
        this.alreadyRegistered = alreadyRegistered;
        this.name = name;
        this.eps = new ArrayList<ImportedEndpoint>();
    }

    public void addImportedEndpoint(ImportedEndpoint ep) {
        eps.add(ep);
    }

    /**
     * @return the alreadyRegistered
     */
    public boolean isAlreadyRegistered() {
        return alreadyRegistered;
    }

    /**
     * @param alreadyRegistered
     *            the alreadyRegistered to set
     */
    public void setAlreadyRegistered(boolean alreadyRegistered) {
        this.alreadyRegistered = alreadyRegistered;
    }

    /**
     * @return the name
     */
    public String getName() {
        return name;
    }

    /**
     * @param name
     *            the name to set
     */
    public void setName(String name) {
        this.name = name;
    }

    /**
     * @return the eps
     */
    public List<ImportedEndpoint> getEps() {
        return eps;
    }

    /**
     * @param eps
     *            the eps to set
     */
    public void setEps(List<ImportedEndpoint> eps) {
        this.eps = eps;
    }

    /**
     * @return the id
     */
    public String getId() {
        return id;
    }

    /**
     * @param id
     *            the id to set
     */
    public void setId(String id) {
        this.id = id;
    }

}
